package jogo;

//import java.awt.Graphics2D;
import java.awt.Graphics2D;
import java.awt.Image;
import java.util.ArrayList;
import java.util.Random;

public class Bomba extends Elemento {

    private Image bomba; // imagem da bomba
    private Image explosao; // imagem da explosao
    private boolean bombaViva; // indica se a bomba ainda nao explodiu
    private int tempoDeVidaDaBomba; // indica o tempo que bomba vai demorar para explodir
    private boolean explodindo; // indica que a bomba esta explodindo
    protected int tempoDeExplosao; // indica o tempo que ira demorar a explosao
    private boolean virouSkill; // indica se um bloco de tijolos virou skill
    private Random varAleatoria = new Random(); // serve para escolher skill rato ou skill gato
    private int tipoDeSkill = 0; // serve para saber se eh a skill gato ou rato
    int atingiuObjetoEsquerda = 100;
    int atingiuObjetoDireita = 100;
    int atingiuObjetoCima = 100;
    int atingiuObjetoBaixo = 100;

    public Bomba(JogoTimer bomba, String imagemNome, int mx, int my, int alcanceBomba) {
        super(bomba, imagemNome, mx, my);
        this.bomba = this.carregarImagem(imagemNome); // carregarImagem recebe como parametro uma string (imagemNome) que contem o nome da imagem da bomba (bomba.png)
        this.explosao = this.carregarImagem("explosao.png");
        this.bombaViva = true;
        this.tempoDeVidaDaBomba = 100;
        this.explodindo = false;
        this.tempoDeExplosao = 50;
        this.virouSkill = false;
        this.alcanceBomba = alcanceBomba; //alcanceBomba; // this.alcanceBomba recebe o alcanceBomba do jogador
    }

    @Override
    // 125ms
    public void atualizar() {
        if (bombaViva) {
            tempoDeVidaDaBomba -= 10;
        }
        if (explodindo) {
            tempoDeExplosao -= 10;
        }
    }

    @Override
    public void desenhar(Graphics2D g) {
        if (bombaViva) {
            g.drawImage(this.bomba, this.posX, this.posY, this.jogo);
            if (tempoDeVidaDaBomba <= 0) {
                this.jogo.cenario[matLinha][matColuna] = 2; // libera a posicao onde estava a bomba depois de ela explodir
                this.bombaViva = false;
                this.explodindo = true;
                this.tempoDeExplosao = this.velocidade * 1; // tempo em que a imagem explodindo fica na tela do jogo
                this.tempoDeVidaDaBomba = (this.tempoDeExplosao / 7); // dando um valor para usar na validacao de skill
            }
        }

        if (explodindo) {
            g.drawImage(this.explosao, this.posX, this.posY, this.jogo); // ponto central da explosao
            this.jogo.atingiuJogador(matLinha, matColuna); // verifica se o jogador esta em cima da bomba (JogoTimer)
            int posicaoExplosao = posX; // posicaoExplosao ira guardar apenas posX porque nessa parte iremos mexer na coluna
            for (int i = 1; i <= alcanceBomba; i++) {
                posicaoExplosao -= 40; // isso ira jogar a imagem da explosao para uma casa a esquerda 
                if (i <= atingiuObjetoEsquerda) {
                    this.jogo.atingiuJogador(matLinha, matColuna - i); // verifica se o jogador foi atingido pela chama da bomba
                    if (this.jogo.cenario[matLinha][matColuna - i] != 0) {
                        g.drawImage(this.explosao, posicaoExplosao, this.posY, this.jogo);
                        if (this.jogo.cenario[matLinha][matColuna - i] == 1) {
                            this.jogo.cenario[matLinha][matColuna - i] = 2;
                            atingiuObjetoEsquerda = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha][matColuna - i] == 3) {
                            tipoDeSkill = varAleatoria.nextInt(3) + 5;
                            this.jogo.cenario[matLinha][matColuna - i] = (short) tipoDeSkill;
                            virouSkill = true;
                            atingiuObjetoEsquerda = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha][matColuna - i] >= 5 && virouSkill == false) {
                            this.jogo.cenario[matLinha][matColuna - i] = 2;
                        }
                    } else {
                        atingiuObjetoEsquerda = i;
                        i = alcanceBomba;

                    }
                }
            }
            posicaoExplosao = posY;
            for (int i = 1; i <= alcanceBomba; i++) {
                posicaoExplosao -= 40;
                if (i <= atingiuObjetoCima) {
                    this.jogo.atingiuJogador(matLinha - i, matColuna);
                    if (this.jogo.cenario[matLinha - i][matColuna] != 0) {
                        g.drawImage(this.explosao, this.posX, posicaoExplosao, this.jogo);
                        if (this.jogo.cenario[matLinha - i][matColuna] == 1) {
                            this.jogo.cenario[matLinha - i][matColuna] = 2;
                            atingiuObjetoCima = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha - i][matColuna] == 3) {
                            tipoDeSkill = varAleatoria.nextInt(3) + 5;
                            this.jogo.cenario[matLinha - i][matColuna] = (short) tipoDeSkill;
                            virouSkill = true;
                            atingiuObjetoCima = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha - i][matColuna] >= 5 && virouSkill == false) {
                            this.jogo.cenario[matLinha - i][matColuna] = 2;
                        }
                    } else {
                        atingiuObjetoCima = i;
                        i = alcanceBomba;
                    }
                }
            }
            posicaoExplosao = posY;
            for (int i = 1; i <= alcanceBomba; i++) {
                posicaoExplosao += 40;
                if (i <= atingiuObjetoBaixo) {
                    this.jogo.atingiuJogador(matLinha + i, matColuna);
                    if (this.jogo.cenario[matLinha + i][matColuna] != 0) {
                        g.drawImage(this.explosao, this.posX, posicaoExplosao, this.jogo);
                        if (this.jogo.cenario[matLinha + i][matColuna] == 1) {
                            this.jogo.cenario[matLinha + i][matColuna] = 2;
                            atingiuObjetoBaixo = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha + i][matColuna] == 3) {
                            tipoDeSkill = varAleatoria.nextInt(3) + 5;
                            this.jogo.cenario[matLinha + i][matColuna] = (short) tipoDeSkill;
                            virouSkill = true;
                            atingiuObjetoBaixo = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha + i][matColuna] >= 5 && virouSkill == false) {
                            this.jogo.cenario[matLinha + i][matColuna] = 2;
                        }
                    } else {
                        atingiuObjetoBaixo = i;
                        i = alcanceBomba;
                    }
                }
            }
            posicaoExplosao = posX;
            for (int i = 1; i <= alcanceBomba; i++) {
                posicaoExplosao += 40;
                if (i <= atingiuObjetoDireita) {
                    this.jogo.atingiuJogador(matLinha, matColuna + i);
                    if (this.jogo.cenario[matLinha][matColuna + i] != 0) {
                        g.drawImage(this.explosao, posicaoExplosao, this.posY, this.jogo);
                        if (this.jogo.cenario[matLinha][matColuna + i] == 1) {
                            this.jogo.cenario[matLinha][matColuna + i] = 2;
                            atingiuObjetoDireita = i; // atingiuObjetoDireita recebe 1, nao entra no if (i <= atingiuObjetoDireita)
                            i = alcanceBomba; // iguala i ao alcance da bomba do jogador para sair do for na proxima passagem
                        } else if (this.jogo.cenario[matLinha][matColuna + i] == 3) {
                            tipoDeSkill = varAleatoria.nextInt(3) + 5;
                            this.jogo.cenario[matLinha][matColuna + i] = (short) tipoDeSkill;
                            virouSkill = true; // para garantir que nao entre no if de baixo, pois a taxa de atualizacao eh muito alta
                            atingiuObjetoDireita = i;
                            i = alcanceBomba;
                        } else if (this.jogo.cenario[matLinha][matColuna + i] >= 5 && virouSkill == false) { // nao entra aqui na primeira bomba
                            this.jogo.cenario[matLinha][matColuna + i] = 2;
                        }
                    } else {
                        atingiuObjetoDireita = i;
                        i = alcanceBomba;
                    }
                }
            }
            
            // funcao para explodir a bomba
            if (tempoDeExplosao <= 0) {
                this.explodindo = false;
                this.tempoDeExplosao = this.velocidade * 2; // tempo em que a imagem da explosao vai ficar na tela
            }
        }
    }
}